<?php
/*

    MixStream All-In-One StreamStats 1.1 - Display SHOUTast stats on any website
    Copyright (C) 2013  Bell Online Ltd

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.

*/



#############################################################
########### No need to edit anything in this file ###########
#############################################################

header("content-type: application/javascript");
include ('./configure.php');
if ($SHOUTcastVersion == 2) {
	$SHOUTcastSID = "?sid=".$SHOUTcastSID;
} else {
	unset($SHOUTcastSID);
}
$ch = curl_init();
curl_setopt($ch, CURLOPT_URL, "http://".$SHOUTcastServer.":".$SHOUTcastPort."/index.html".$SHOUTcastSID);
curl_setopt($ch, CURLOPT_USERAGENT, "Mozilla");
curl_setopt($ch, CURLOPT_RETURNTRANSFER, 1);
curl_setopt($ch, CURLOPT_CONNECTTIMEOUT, 2);
$SHOUTcastData = curl_exec($ch);
curl_close($ch);
if (!$SHOUTcastData) {
	$SHOUTcastStatus['refused'] = utf8_encode(str_replace('"', '\"', $SHOUTcastStatus['refused']));
	print 'document.getElementById(\'SHOUTcastStatus\').innerHTML="'.$SHOUTcastStatus['refused'].'";'.PHP_EOL;
	$SHOUTcastServerIP = gethostbyname($SHOUTcastServer);
	print PHP_EOL.'/* If the server at http://'.$SHOUTcastServer.':'.$SHOUTcastPort.'/ is online'.PHP_EOL.'then you may need to contact your web host and ask them to'.PHP_EOL.'allow you to connect to \''.$SHOUTcastServerIP.'\' using php cURL. */';
	exit;
}
if ($SHOUTcastVersion == 2) {
	preg_match_all('/<font class="default"><b>(.*?)<\/b>/si', $SHOUTcastData, $matches);
} else {
	preg_match_all('/<font class=default><b>(.*?)<\/b>/si', $SHOUTcastData, $matches);
}
$i = 1;
$last = count($matches[1]);
foreach ($matches[1] as $val) {
	$val = str_replace('"', '\"', $val);
	if ($i == 1) {
		if ($val == "Server is currently down.") {
			$SHOUTcastStatus['down'] = utf8_encode(str_replace('"', '\"', $SHOUTcastStatus['down']));
			print 'document.getElementById(\'SHOUTcastStatus\').innerHTML="'.$SHOUTcastStatus['down'].'";'.PHP_EOL;
		} else {
			$SHOUTcastStatus['up'] = utf8_encode(str_replace('"', '\"', $SHOUTcastStatus['up']));
			print 'document.getElementById(\'SHOUTcastStatus\').innerHTML="'.$SHOUTcastStatus['up'].'";'.PHP_EOL;
		}
	} else if ($i == 2) {
		preg_match_all('!\d+!', $val, $streamStatusMatches);		
		print 'document.getElementById(\'SHOUTcastBitrate\').innerHTML="'.$streamStatusMatches[0][0].'";'.PHP_EOL;
		print 'document.getElementById(\'SHOUTcastListeners\').innerHTML="'.$streamStatusMatches[0][1].'";'.PHP_EOL;
		print 'document.getElementById(\'SHOUTcastListenersMax\').innerHTML="'.$streamStatusMatches[0][2].'";'.PHP_EOL;
		print 'document.getElementById(\'SHOUTcastListenersUnique\').innerHTML="'.$streamStatusMatches[0][3].'";'.PHP_EOL;
	} else if ($i == 3) {
		print 'document.getElementById(\'SHOUTcastListenersPeak\').innerHTML="'.$val.'";'.PHP_EOL;
	} else if ($i == 4) {
		print 'document.getElementById(\'SHOUTcastAverageListenTime\').innerHTML="'.$val.'";'.PHP_EOL;
	} else if ($i == 5) {
		print 'document.getElementById(\'SHOUTcastTitle\').innerHTML="'.$val.'";'.PHP_EOL;
	} else if ($i == 6) {
		if ($val == "audio/mpeg") {
			print 'document.getElementById(\'SHOUTcastFormat\').innerHTML="MP3";'.PHP_EOL;
		} else if ($val == "audio/aac") {
			print 'document.getElementById(\'SHOUTcastFormat\').innerHTML="AAC+";'.PHP_EOL;
		} else if ($val == "video/nsv") {
			print 'document.getElementById(\'SHOUTcastFormat\').innerHTML="NSV Video";'.PHP_EOL;
		} else {
			print 'document.getElementById(\'SHOUTcastFormat\').innerHTML="Unknown";'.PHP_EOL;
		}
	} else if ($i == 7) {
		print 'document.getElementById(\'SHOUTcastGenre\').innerHTML="'.$val.'";'.PHP_EOL;
	} else if ($i == $last) {
		print 'document.getElementById(\'SHOUTcastSong\').innerHTML="'.$val.'";'.PHP_EOL;
	}
	$i++;
}
if ($showHistory == 1) {
	$ch = curl_init();
	curl_setopt($ch, CURLOPT_URL, "http://".$SHOUTcastServer.":".$SHOUTcastPort."/played.html".$SHOUTcastSID);
	curl_setopt($ch, CURLOPT_USERAGENT, "Mozilla");
	curl_setopt($ch, CURLOPT_RETURNTRANSFER, 1);
	curl_setopt($ch, CURLOPT_CONNECTTIMEOUT, 2);
	$SHOUTcastData = curl_exec($ch);
	curl_close($ch);
	if ($SHOUTcastData) {
		print 'document.getElementById(\'SHOUTcastHistory\').innerHTML="<table class=\"'.$tableClass.'\">';
		$match = preg_match_all('/<\/td><td>(.*?)<\/tr><tr>/si', $SHOUTcastData, $matches);
		$i = 1;
		foreach ($matches[1] as $val) {
			if ($val != "") {
				if ($i == 3) {
					$show = 1;	
				}
				if ($show) {
					if (strpos($val,'</table>') !== false) {
						break;
					}
					print utf8_encode(str_replace('"', '\"', "  <tr><td>{$val}</td></tr>"));
				}
				$i++;
			}
		}
		print "</table>\";".PHP_EOL;
	}
}
print "
/* 
	Script downloaded from http://mixstream.net/streaming/resources/
	Please retain this credit in return for this free script.
*/";
?>